> For the complete documentation index, see [llms.txt](https://docs.akamas.io/akamas-docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.akamas.io/akamas-docs/reference/optimization-packs/kubernetes-pack/hpa_v1.md).

# Horizontal Pod Autoscaler v1

This page describes the Kubernetes HPA v1 component type. The reference documentation for this HPA can be found [here](https://kubernetes.io/docs/reference/kubernetes-api/workload-resources/horizontal-pod-autoscaler-v1/).

## Metrics

| Name                    | Unit | Description                                                                                          |
| ----------------------- | ---- | ---------------------------------------------------------------------------------------------------- |
| k8s\_hpa\_min\_replicas | pods | The lower limit for the number of replicas to which the autoscaler can scale down.                   |
| k8s\_hpa\_max\_replicas | pods | The upper limit for the number of replicas to which the autoscaler can scale up.                     |
| k8s\_desired\_replicas  | pods | Desired number of replicas of pods managed by this autoscaler, as last calculated by the autoscaler. |
| k8s\_current\_replicas  | pods | Current number of replicas of pods managed by this autoscaler, as last seen by the autoscaler.       |

## Parameters

| Parameter                      | Type    | Unit       | Default                                   | Domain                             | Restart | Description                                                                                                                                                                                                                                                                                            |
| ------------------------------ | ------- | ---------- | ----------------------------------------- | ---------------------------------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| min\_replicas                  | integer | pods       | You should select your own default value. | You should select your own domain. | yes     | The lower limit for the number of replicas to which the autoscaler can scale down. min\_replicas is allowed to be 0 if the alpha feature gate HPAScaleToZero is enabled and at least one Object or External metric is configured. Scaling is active as long as at least one metric value is available. |
| max\_replicas                  | integer | pods       | You should select your own default value. | You should select your own domain. | yes     | The upper limit for the number of replicas to which the autoscaler can scale up. It cannot be less that min\_replicas.                                                                                                                                                                                 |
| targetCPUUtilizationPercentage | integer | percentage | You should select your own default value. | 1 - 100                            | yes     | The target average CPU utilization (represented as a percentage of the requested CPU) over all the pods in the autoscaled deployment.                                                                                                                                                                  |

## Constraints

The following tables show a list of constraints that may be required in the definition of the study, depending on the tuned parameters:

| Formula                                                       | Notes                                        |
| ------------------------------------------------------------- | -------------------------------------------- |
| component\_name.min\_replicas < component\_name.max\_replicas | Min replicas must be lower than max replicas |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.akamas.io/akamas-docs/reference/optimization-packs/kubernetes-pack/hpa_v1.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
